import React from "react";
import { OK, BAD } from "../shared/StatusMessage";
import Tile from "../shared/Tile";
import useApi from "../../hooks/useApi";

const trimLen = 20;
const ms = 1000 * 60;

export default () => {
  const [rawHealth, rawData] = useApi("https://kirkleon.ddns.net/minecraft/", { ms });

  let health = BAD;
  let message = null;
  if (rawHealth === OK) {
    const {
      online,
      data,
    } = rawData;
    if (online) {
      health = OK;
      const {
        currentPlayers,
        maxPlayers,
        motd,
        version,
      } = data;
      const playerString = `${currentPlayers}/${maxPlayers} playing`;
      const info = `${version} - ${motd}`;
      const trimmedInfo = info.length > trimLen
                        ? info.substring(0, trimLen - 3) + "..."
                        : info
      message = `${trimmedInfo}: ${playerString}`;
    }
  }

  return <Tile
    link="https://kirkleon.ddns.net/minecraft/map/"
    title="Minecraft Server"
    health={health}
    data={message}
  />
}